"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignalEmitter = void 0;
const analytics_generic_utils_1 = require("@segment/analytics-generic-utils");
const logger_1 = require("../../lib/logger");
class SignalEmitter {
    constructor() {
        this.emitter = new analytics_generic_utils_1.Emitter();
    }
    emit(signal) {
        logger_1.logger.debug('new signal emitted', signal);
        this.emitter.emit('add', signal);
    }
    subscribe(broadcaster) {
        logger_1.logger.debug('subscribed');
        this.emitter.on('add', broadcaster);
    }
    unsubscribe(listener) {
        logger_1.logger.debug('unsubscribed');
        this.emitter.off('add', listener);
    }
}
exports.SignalEmitter = SignalEmitter;
//# sourceMappingURL=index.js.map