"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignalEventProcessor = void 0;
const logger_1 = require("../../lib/logger");
class SignalEventProcessor {
    constructor(analytics, sandbox) {
        this.analytics = analytics;
        this.sandbox = sandbox;
    }
    async process(signal, signals) {
        const analyticsMethodCalls = await this.sandbox.process(signal, signals);
        for (const methodName in analyticsMethodCalls) {
            const name = methodName;
            const eventsCollection = analyticsMethodCalls[name];
            eventsCollection.forEach((args) => {
                logger_1.logger.debug(`analytics.${name}(...) called with args`, args);
                // @ts-ignore
                this.analytics[name](...args);
            });
        }
    }
    cleanup() {
        return this.sandbox.jsSandbox.destroy();
    }
}
exports.SignalEventProcessor = SignalEventProcessor;
//# sourceMappingURL=processor.js.map