"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeUrl = void 0;
/**
 * Normalize URL provided by the fetch API into a valid URL string that can be used with new URL.
 */
const normalizeUrl = (urlOrPath) => {
    if (urlOrPath.startsWith('http')) {
        return urlOrPath;
    }
    if (urlOrPath.startsWith('/')) {
        return window.location.origin + urlOrPath;
    }
    if (urlOrPath.includes('.')) {
        return `${location.protocol}//${urlOrPath}`;
    }
    return window.location.origin + '/' + urlOrPath;
};
exports.normalizeUrl = normalizeUrl;
//# sourceMappingURL=index.js.map