import { Emitter } from '@segment/analytics-generic-utils';
import { logger } from '../../lib/logger';
export class SignalEmitter {
    constructor() {
        this.emitter = new Emitter();
    }
    emit(signal) {
        logger.debug('new signal emitted', signal);
        this.emitter.emit('add', signal);
    }
    subscribe(broadcaster) {
        logger.debug('subscribed');
        this.emitter.on('add', broadcaster);
    }
    unsubscribe(listener) {
        logger.debug('unsubscribed');
        this.emitter.off('add', listener);
    }
}
//# sourceMappingURL=index.js.map