import { logger } from '../../lib/logger';
export class SignalEventProcessor {
    constructor(analytics, sandbox) {
        this.analytics = analytics;
        this.sandbox = sandbox;
    }
    async process(signal, signals) {
        const analyticsMethodCalls = await this.sandbox.process(signal, signals);
        for (const methodName in analyticsMethodCalls) {
            const name = methodName;
            const eventsCollection = analyticsMethodCalls[name];
            eventsCollection.forEach((args) => {
                logger.debug(`analytics.${name}(...) called with args`, args);
                // @ts-ignore
                this.analytics[name](...args);
            });
        }
    }
    cleanup() {
        return this.sandbox.jsSandbox.destroy();
    }
}
//# sourceMappingURL=processor.js.map