import { Signal } from '@segment/analytics-signals-runtime';
export interface SignalPersistentStorage {
    getAll(): Promise<Signal[]> | Signal[];
    add(value: Signal): Promise<void> | void;
    clear(): void;
}
export declare class SignalStore implements SignalPersistentStorage {
    static readonly DB_NAME = "Segment Signals Buffer";
    static readonly STORE_NAME = "signals";
    private signalStore;
    private signalCount;
    private maxBufferSize;
    length(): number;
    static deleteDatabase(): IDBOpenDBRequest;
    constructor(settings?: {
        maxBufferSize?: number;
    });
    private getStore;
    private createSignalStore;
    private initializeSignalCount;
    add(signal: Signal): Promise<void>;
    /**
     * Get list of signals from the store, with the newest signals first.
     */
    getAll(): Promise<Signal[]>;
    clear(): Promise<void>;
}
export declare class SignalBuffer<T extends SignalPersistentStorage = SignalPersistentStorage> {
    store: T;
    constructor(store: T);
    add(signal: Signal): Promise<void>;
    getAll(): Promise<Signal[]>;
    clear(): Promise<void>;
}
export interface SignalBufferSettingsConfig<T extends SignalPersistentStorage = SignalPersistentStorage> {
    maxBufferSize?: number;
    signalStorage?: T;
}
export declare const getSignalBuffer: <T extends SignalPersistentStorage = SignalPersistentStorage>(settings: SignalBufferSettingsConfig<T>) => SignalBuffer<SignalStore | T>;
//# sourceMappingURL=index.d.ts.map