import { JSONValue } from '@segment/analytics-next';
export interface NetworkInterceptorRequest {
    url: string;
    method: string;
    contentType: string | undefined;
    body: string | undefined;
    headers: Headers | undefined;
    id: string;
}
export interface NetworkInterceptorResponse {
    url: string;
    status: number;
    ok: boolean;
    statusText: string;
    headers: Headers;
    body: () => Promise<JSONValue>;
    initiator: 'fetch' | 'xhr';
    responseType: XMLHttpRequestResponseType | undefined;
    req: {
        id: string;
    };
}
/**
 * Taken from https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/response
 */
export interface NetworkResponseHandler {
    (rs: NetworkInterceptorResponse): void;
}
export interface NetworkRequestHandler {
    (rq: NetworkInterceptorRequest): void;
}
/**
 * NetworkInterceptor class to intercept network requests and responses
 */
export declare class NetworkInterceptor {
    addInterceptors(onRequest: NetworkRequestHandler, onResponse: NetworkResponseHandler): void;
    private addFetchInterceptor;
    private addXhrInterceptor;
    cleanup(): void;
}
//# sourceMappingURL=network-interceptor.d.ts.map