/**
 * Copyright 2022 Mark Wylde
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */
/**
 * Whenever this script is modified, we need to run `yarn workerbox` and commit the result.
 * This happens via lint-staged (on commit that modifiies the enclosing folder), so it should be automatic.
 */
export declare function stringToScope(object: any, addCallback: Function, runCallback: Function): any;
export declare function createCallbackStore(): {
    store: Record<string, Function>;
    add: (fn: Function) => string;
    get: (id: string) => Function;
};
export declare function scopeToString(scope: any, addCallback: Function, runCallback: Function): string;
export declare function argsToString(args: any, addCallback: Function, runCallback: Function): string;
export declare function stringToArgs(args: any, addCallback: Function, runCallback: Function): any;
export declare function createWorkerboxInstance(url: string | undefined, onMessage: MessagePort['onmessage']): Promise<{
    postMessage: (message: any) => void;
    destroy: () => void;
}>;
export interface WorkerBoxOptions {
    url?: string;
}
export interface WorkerBoxAPI {
    run: (code: string, scope: Record<string, any>) => Promise<void>;
    destroy: () => void;
    opts?: WorkerBoxOptions;
}
declare function createWorkerBox(opts?: WorkerBoxOptions): Promise<WorkerBoxAPI>;
export { createWorkerBox };
//# sourceMappingURL=index.d.ts.map